VERSION 5.00
Begin VB.Form frmReplaceFont 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Replace Font v1.01"
   ClientHeight    =   1575
   ClientLeft      =   31710
   ClientTop       =   3195
   ClientWidth     =   7980
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Microsoft Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "ReplaceFont.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1575
   ScaleWidth      =   7980
   ShowInTaskbar   =   0   'False
   Begin VB.CheckBox chkCtlAndPag 
      Caption         =   "Examine CTL && PAG modules also"
      Height          =   195
      Left            =   180
      TabIndex        =   14
      Top             =   1320
      Value           =   1  'Checked
      Width           =   3075
   End
   Begin VB.CommandButton cmdList 
      Caption         =   "List w Font"
      Height          =   315
      Left            =   6720
      TabIndex        =   6
      Top             =   180
      Width           =   1155
   End
   Begin VB.CommandButton cmdHide 
      Cancel          =   -1  'True
      Caption         =   "Hide Me"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   6660
      TabIndex        =   10
      Top             =   1080
      Width           =   1275
   End
   Begin VB.Frame fraScope 
      Caption         =   "Scope"
      Height          =   1275
      Left            =   120
      TabIndex        =   11
      Top             =   0
      Width           =   3315
      Begin VB.OptionButton optScope 
         Caption         =   "All Forms in Project, Forms && Controls"
         Height          =   195
         Index           =   3
         Left            =   240
         TabIndex        =   3
         Top             =   960
         Width           =   3015
      End
      Begin VB.OptionButton optScope 
         Caption         =   "All Forms in Project, Just Forms"
         Height          =   195
         Index           =   2
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   3015
      End
      Begin VB.OptionButton optScope 
         Caption         =   "Selected Form, Form && All Controls"
         Height          =   195
         Index           =   1
         Left            =   240
         TabIndex        =   1
         Top             =   480
         Width           =   3015
      End
      Begin VB.OptionButton optScope 
         Caption         =   "Selected Form, Just Form"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   0
         Top             =   240
         Value           =   -1  'True
         Width           =   3015
      End
   End
   Begin VB.CommandButton cmdMicrosoftSansSerif 
      Caption         =   "Microsoft Sans Serif"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   7200
      TabIndex        =   8
      Top             =   600
      Width           =   735
   End
   Begin VB.CommandButton cmdSegoeUI 
      Caption         =   "Segoe UI"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   6660
      TabIndex        =   7
      Top             =   600
      Width           =   495
   End
   Begin VB.ComboBox cboTo 
      Height          =   315
      Left            =   3900
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   600
      Width           =   2775
   End
   Begin VB.ComboBox cboFrom 
      Height          =   315
      Left            =   3900
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   180
      Width           =   2775
   End
   Begin VB.CommandButton cmdReplace 
      Caption         =   "Do The Font Replacement(s)"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   3480
      TabIndex        =   9
      Top             =   1080
      Width           =   3135
   End
   Begin VB.Label lbl 
      Alignment       =   1  'Right Justify
      Caption         =   "To:"
      Height          =   255
      Index           =   1
      Left            =   3360
      TabIndex        =   13
      Top             =   615
      Width           =   495
   End
   Begin VB.Label lbl 
      Alignment       =   1  'Right Justify
      Caption         =   "From:"
      Height          =   255
      Index           =   0
      Left            =   3360
      TabIndex        =   12
      Top             =   195
      Width           =   495
   End
End
Attribute VB_Name = "frmReplaceFont"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
Public VBInstance   As VBIDE.VBE
Public Connect      As Connect
'

Private Sub cmdList_Click()
    Dim vbp         As VBProject
    Dim cmp         As VBComponent
    Dim FontProp    As StdFont
    Dim sList       As String
    Dim bFound      As Boolean
    Dim frm         As VBForm
    Dim ctl         As VBControl
    Dim bOpen       As Boolean
    '
    If VBInstance.VBProjects.Count > 1 Then
        MsgBox "This doesn't currently work for VB groups.  Please open individual projects and try again.", vbCritical, App.Title
        Exit Sub
    End If
    '
    Set vbp = VBInstance.VBProjects(1)
    '
    For Each cmp In vbp.VBComponents
        If WereInterestedInCmp(cmp) Then
            bFound = False
            bOpen = cmp.HasOpenDesigner
            Set FontProp = GetStdFont(cmp)
            If FontProp.Name = cboFrom.Text Then bFound = True
            If Not bFound Then
                Set frm = cmp.Designer
                For Each ctl In frm.VBControls              ' For Each ctl In frm.ContainedVBControls (would only get the controls not in deeper containers).
                    Set FontProp = GetStdFont(ctl)
                    If Not FontProp Is Nothing Then
                        If FontProp.Name = cboFrom.Text Then
                            bFound = True
                            Exit For
                        End If
                    End If
                Next
            End If
            If bFound Then sList = sList & cmp.Name & vbCrLf
            If Not bOpen Then cmp.DesignerWindow.Close
        End If
    Next
    '
    MsgBox "Forms With " & cboFrom.Text & ":" & vbCrLf & vbCrLf & sList, vbInformation, App.Title
End Sub

Private Sub cmdReplace_Click()
    Dim vbp         As VBProject
    Dim cmp         As VBComponent
    Dim FontProp    As StdFont
    Dim Index       As Long
    Dim bChanged    As Boolean
    Dim bOpen       As Boolean
    '
    If VBInstance.VBProjects.Count > 1 Then
        MsgBox "This doesn't currently work for VB groups.  Please open individual projects and try again.", vbCritical, App.Title
        Exit Sub
    End If
    If cboFrom.Text = cboTo.Text Then
        MsgBox "You have the same font set in the ""From"" and ""To"" boxes.  You must correct this before continuing.", vbCritical, App.Title
        Exit Sub
    End If
    '
    Set vbp = VBInstance.VBProjects(1)
    Index = SelectedOptIndex(optScope)
    '
    Select Case Index
    Case 0, 1                                       ' Selected Form, Just Form or Form & All Controls.
        Set cmp = VBInstance.SelectedVBComponent
        If Not WereInterestedInCmp(cmp) Then
            MsgBox "It's not a FORM that's selected." & vbCrLf & "You must select a form to use this.", vbCritical, App.Title
            Exit Sub
        End If
        '
        bOpen = cmp.HasOpenDesigner                 ' We've got to save this because changing the font opens the designer (although not visible).
        Set FontProp = GetStdFont(cmp)
        bChanged = CheckAndChangeFont(FontProp)
        If Index = 1 Then bChanged = DoTheControls(cmp) Or bChanged     ' See if we do the controls too.
        '
        ' Now we make sure the Properties Window reports things correctly.
        ' And we set the IsDirty flag, which helps with this, and also informs the IDE what to save.
        If bChanged Then
            cmp.IsDirty = True
            If bOpen Then
                cmp.DesignerWindow.Close
                cmp.DesignerWindow.Visible = True
                cmp.DesignerWindow.SetFocus
            End If
        End If
    Case 2, 3                                       ' All Forms in Project, Just Forms or Forms & All Controls.
        For Each cmp In vbp.VBComponents
            If WereInterestedInCmp(cmp) Then
                bChanged = False
                bOpen = cmp.HasOpenDesigner         ' We've got to save this because changing the font opens the designer (although not visible).
                Set FontProp = GetStdFont(cmp)
                bChanged = CheckAndChangeFont(FontProp)
                If Index = 3 Then bChanged = DoTheControls(cmp) Or bChanged
                '
                ' This time, we don't mess with setting the focus.
                If bChanged Then
                    cmp.IsDirty = True
                    If bOpen Then
                        cmp.DesignerWindow.Close
                        cmp.DesignerWindow.Visible = True
                    End If
                End If
                If Not bOpen Then cmp.DesignerWindow.Close  ' They get opened invisibly, and we must be careful with resources.
            End If
        Next
    End Select
    '
End Sub

Private Function WereInterestedInCmp(cmp As VBComponent) As Boolean
    If cmp.Type = vbext_ct_VBForm Then WereInterestedInCmp = True
    If chkCtlAndPag.Value = vbChecked Then
        If cmp.Type = vbext_ct_PropPage Then WereInterestedInCmp = True
        If cmp.Type = vbext_ct_UserControl Then WereInterestedInCmp = True
    End If
End Function

Private Function DoTheControls(cmp As VBComponent) As Boolean
    ' Returns true if something changed.
    Dim FontProp    As StdFont
    Dim frm         As VBForm
    Dim ctl         As VBControl
    '
    Set frm = cmp.Designer
    For Each ctl In frm.VBControls              ' For Each ctl In frm.ContainedVBControls (would only get the controls not in deeper containers).
        Set FontProp = GetStdFont(ctl)
        DoTheControls = CheckAndChangeFont(FontProp) Or DoTheControls
    Next
End Function

Private Function CheckAndChangeFont(FontProp As StdFont) As Boolean
    ' Returns true if something changed.
    If Not FontProp Is Nothing Then
        If FontProp.Name = cboFrom.Text Then
            FontProp.Name = cboTo.Text
            CheckAndChangeFont = True
        End If
    End If
End Function

Private Sub Form_Load()
    Dim i As Long
    '
    Top = 300
    Left = 300
    '
    For i = 0 To Screen.FontCount - 1
        cboFrom.AddItem Screen.Fonts(i)
        cboTo.AddItem Screen.Fonts(i)
    Next
    '
    On Error Resume Next
        cboFrom.Text = "MS Sans Serif"
        cboTo.Text = "Microsoft Sans Serif"
    On Error GoTo 0
End Sub

Private Sub cmdMicrosoftSansSerif_Click()
    On Error Resume Next
        cboTo.Text = "Microsoft Sans Serif"
    On Error GoTo 0
End Sub

Private Sub cmdSegoeUI_Click()
    On Error Resume Next
        cboTo.Text = "Segoe UI"
    On Error GoTo 0
End Sub

Private Sub cmdHide_Click()
    Connect.ConnectHide
End Sub

Private Function SelectedOptIndex(opt As Object) As Variant
    ' Returns the index number of a selected option button
    ' in an option button array.  Returns NULL if none selected.
    Dim o As OptionButton
    '
    For Each o In opt
        If o.Value Then
            SelectedOptIndex = o.Index
            Exit Function
        End If
    Next o
    SelectedOptIndex = Null
End Function

Private Function GetStdFont(obj As Object) As StdFont
    ' Returns Nothing if object doesn't have a font property.
    On Error Resume Next
        Set GetStdFont = obj.Properties("Font").Object
    On Error GoTo 0
End Function
